' This VBScript source gets a picture's date taken time and applies
' it to the file times
'
' Usage:
'	cscript SetFileTimeToPictureDateTakenTime.vbs  "directory" "file"
' e.g.
'	cscript SetFileTimeToPictureDateTakenTime.vbs "???"
'
' Copyright JD Design 2010


Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFile = objFSO.GetFile( WScript.Arguments(0) )
'Wscript.Echo "Absolute path: " & objFSO.GetAbsolutePathName(objFile)
'Wscript.Echo "Parent folder: " & objFSO.GetParentFolderName(objFile) 
'Wscript.Echo "File name: " & objFSO.GetFileName(objFile)
'Wscript.Echo "Base name: " & objFSO.GetBaseName(objFile)
'Wscript.Echo "Extension name: " & objFSO.GetExtensionName(objFile)

Set objShell = CreateObject("Shell.Application")

'foldername = WScript.Arguments(0)
'filename = WScript.Arguments(1)
foldername = objFSO.GetParentFolderName(objFile)
filename = objFSO.GetFileName(objFile)

Set objFolder = objShell.NameSpace( foldername )
Set objFolderItem = objFolder.ParseName( filename )

' "Date taken" is 25 on XP, 12 on Vista and later OS's (AFAIK)
DateTakenNum = 12

strHeader = objFolder.GetDetailsOf(objFolder.Items, DateTakenNum )
'Wscript.Echo strHeader & ": " & dt

If strHeader <> "Date taken" Then
  DateTakenNum = 25
'  strHeader = objFolder.GetDetailsOf(objFolder.Items, DateTakenNum )
End If

dt = objFolder.GetDetailsOf(objFolderItem, DateTakenNum )

'Strip off any Left2Right orRight2Left characters (Windows 7)
dt = Replace( dt, ChrW(&H200e), "" )
dt = Replace( dt, ChrW(&H200f), "" )

'Wscript.Echo strHeader & ": " & dt

If IsDate(dt) Then

  'Execute TouchCmd to touch the folder
  Dim WshShell
  Set WshShell = WScript.CreateObject("WScript.Shell")

  Dim progname
  'Add quotes around the path to TouchCmd
  progname = Chr(34) & WshShell.ExpandEnvironmentStrings("%programfiles%\JD Design\TouchPro\TouchCmd.exe") & Chr(34)
'  WScript.Echo "progname: " & progname
  Dim params
  params = "/D" & DateValue( dt )
  params = params & " /T" & TimeValue( dt )
  params = params & " /M /F " & Chr(34) & objFile & Chr(34)
  progname = progname & " " & params
  'WScript.echo progname
  WshShell.Run progname, , True
  Stop

End If

